function y = logit(x)
%  apply logit transform
%  y = logit(x)
%  where logit is defined by y = log(x/(1-x))
%  intended for 0<x<1

% Copyright (c) 1998 by Datatool
% $Revision: 1.00 $

%  deal with large x if necessary
if x>=1
   y = 1/eps;
else
   y = x./(1-x);
end

%  deal with small x if necessary
if y<=0
   y = eps;
end

y = log(y);
