function f = correctfactor_pathabsorption(ang, SDD, nu_medium)
%function correctfactor_pathabsorption(ang, nu_medium)
% ang is an angle array generated by det_geometry.m
% SDD is the sample to detector distance in mm.
% nu_medium is the linear absorption coefficient of the medium (1/cm) 
% that absorps the scattering generated from a sample on the way to arrive 
% to a detector.
% Default medium is assumed to be a air at 25C and 13.3keV
if nargin < 3
    nu_medium = 0.0033; % 1/cm
end

% SDD/10 is to convert mm to cm
f = 1./exp(-nu_medium*SDD/10./cos(ang*pi/180));

