function C = GIXS_airpath_correction(GIXS, u)
% function C = GIXS_airpath_correction(GIXS, u)
% u is the linear absorption coefficient of air
if nargin == 1
    u = 0.0011839; % from Jiang's manual.
    switch GIXS.xeng
        case 7.35
            u = 0.0015; % N1.562O.42C.0003Ar.0094 Pressure=760. Path=0.1 cm, 
                        % T = 0.99852
        case 12         % N1.562O.42C.0003Ar.0094 Pressure=760. Path=0.1 cm, 
            u = 3.3005e-04; % T = 0.99967
    end
end
SDD = GIXS.SDD;
C = 1./exp(-u*SDD./cos(GIXS.tth));