function [E, Ri, Ti] = efieldcal_ang(ai, z, lambda, eden, beta, zinterface, roughness)
% incident angle, ai = 0.005:0.001:0.4
% z : z position at out of plane direction.
%   ex, z = 100:-1:-500;
% lambda = 1.68;
% eden : electron density of medium (length of eden = 1 + length of z(position of interface)
%       eden = [0, 0.35, 0.7]
% beta
% zinterface : position of interfaces
%       z = [0, -500];
% roughness
%       roughness = [10, 3];
r0 = 2.82E-5;
%k0 = 2*pi/lambda;
ai = ai(:);
Ei = zeros(length(z), length(ai));
%Ef = zeros(length(z), length(ai));
%E = zeros(length(z), length(ai));
s.eden = eden;s.beta = beta;s.zin = zinterface;s.sig = roughness;
[s, eden, beta, zinterface, roughness] = slabProfile(s);
d1 = 1/(2*pi)*r0*lambda^2*eden;
b1 = beta;
%n = length(zinterface);                                                      % number of interface
nx = 1-d1+j*b1;
sig = roughness;

[Ri, Ti, kiz] = dwbaxr_old(ai, nx,  zinterface, sig, lambda);kiz = -kiz;   %because, incident beam will go down

for i=1:length(ai)
    Ei(:,i) = efieldcal(z, zinterface, kiz(i, :), Ti(i, :), Ri(i, :))';
end
E = abs(Ei).^2;