function [tthiT, tthfT, afT, tthiR, tthfR, afR] = kl2angle(k, l, B, C, ai, waveln)
% for a cubic structure that is oriented perfectly. a to x, b to y, c to z.
% All the number should be scalars.
ai = deg2rad(ai);
res = 100000;
qz = 2*pi/C*l;
qy = 2*pi/B*k;
qx = 0;
k0 = 2*pi/waveln;

af = asin(qz/k0 - sin(ai));
sin_tthi = (cos(af).^2 - cos(ai).^2 - qy.^2)/(2*cos(ai)*qy);
sin_tthf = sin_tthi*cos(ai)./cos(af) + qy./cos(af);
tthi = asin(sin_tthi);
tthf = asin(sin_tthf);

if ~isreal(tthi) | ~isreal(af) | ~isreal(tthf)
    tthi = NaN;
    af = NaN;
    tthf = NaN;
else
    tthiT = fix(tthi*180/pi*res)/res;
    afT = fix(af*180/pi*res)/res;
    tthfT = fix(tthf *180/pi*res)/res;
end


af = asin(qz/k0 + sin(ai));
sin_tthi = (cos(af).^2 - cos(ai).^2 - qy.^2)/(2*cos(ai)*qy);
sin_tthf = sin_tthi*cos(ai)./cos(af) + qy./cos(af);
tthi = asin(sin_tthi);
tthf = asin(sin_tthf);
if ~isreal(tthi) | ~isreal(af) | ~isreal(tthf)
    tthiR = NaN;
    afR = NaN;
    tthfR = NaN;
else
    tthiR = fix(tthi*180/pi*res)/res;
    tthfR = fix(tthf*180/pi*res)/res;
    afR = fix(af*180/pi*res)/res;
end


%tthfR = tthfR *180/pi;
%afR = afR*180/pi;
%tthiR = tthiR*180/pi;