function h = SAXSLee_showscanparameter
% SHOWSCAN Called by SAXSLee to show the current scan data.

hFigSAXSLee = evalin('base', 'SAXSLee_Handle');
Nsel = get(findobj(hFigSAXSLee, 'tag', 'SAXSLee_PopupmenuX'), 'value');
%settings = getappdata(hFigSAXSLee,'settings');
setall = evalin('base', 'setall');

% --- open GUI to display the selected scans
h = findobj('Tag','figSAXSLeeShowScan');
isNew = 1;
if ~isempty(h)
    figure(h);
    isNew = 0;
else
    p0      = get(hFigSAXSLee,'position');    % main figure position
    p1(3)   = 500;              % p1 is the setting figure position
    p1(4)   = 400;
    p1(1)   = p0(1)+p0(3)/2-p1(3)/2;
    p1(2)   = p0(2)+p0(4)/2-p1(4)/2;
    h = figure(...
        'Units','pixels',...
        'MenuBar','none',...
        'Units','pixels',...
        'Name','SAXSLee - Scan information',...
        'NumberTitle','off',...
        'IntegerHandle','off',...
        'Position',p1,...
        'ResizeFcn',@resizefcn,...
        'HandleVisibility','callback',...
        'Tag','figSAXSLeeShowScan',...
        'WindowStyle','normal',...
        'UserData',[]);
    panelSize = [10 60 p1(3)-20 p1(4)-70];
    hPanel1 = uipanel(...
        'Parent',h,...
        'BackgroundColor',get(h,'Color'),...
        'Title','Select Scan',...
        'Units','pixels',...
        'Tag','figSAXSLeeshowscan_panel1',...
        'Position',panelSize);
%     hPopupmenu1 = uicontrol(...
%         'Parent',hPanel1,...
%         'Style','popupmenu',...
%         'HorizontalAlignment','left',...
%         'BackgroundColor','w',...
%         'Position',[10 panelSize(4)-40 panelSize(3)-20 20],...
%         'String','No scan selected',...
%         'Value',1,...
%         'callback',@callback_popupmenu1,...
%         'Tag','figSAXSLeeshowscan_popupmenu1');
%     hEdit2 = uicontrol(...
%         'Parent',hPanel1,...
%         'Style','edit',...
%         'BackgroundColor','w',...
%         'Position',[10 10 panelSize(3)-20 panelSize(4)-60],...
%         'String','',...
%         'FontName', 'Helvetica',...
%         'Max',2,...
%         'Min',0,...
%         'HorizontalAlignment','left',...
%         'Tag','figSAXSLeeshowscan_edit2');
     uicontrol(...
        'Parent',h,...
        'Style','pushbutton',...
        'String','Refresh',...
        'tag','figSAXSLeeshowscan_pushbuttonRefresh',...
        'Position',[20 20 50 25],...
        'callback','SAXSLee_showscanparameter;');
    uicontrol(...
        'Parent',h,...
        'Style','pushbutton',...
        'String','Close',...
        'tag','figSAXSLeeshowscan_pushbuttonClose',...
        'Position',[p1(3)/2+10 20 50 25],...
        'Callback','delete(gcf);');
end


file = setall{Nsel}.file;
scan = setall{Nsel}.scan;

if isempty(file) || isempty(scan) || ~isfield(scan,'selection') || isempty(scan.selection{1})
    return;
end

% --- load the scan text
selection = scan.selectionIndex;
%scanHead = cell(length(selection),1);
Text = '';
scanText = {};
m = 1;
for iSelection = 1:length(selection)
    imgname = scan.filen{selection(iSelection)};
    c = specSAXSn2(file, imgname);
    fn = fieldnames(c);
    for k=1:numel(fn)
        str = c.(fn{k});
        if iscell(str)
            pstr = cell2mat(str);
        elseif isnumeric(str)
            pstr = num2str(str);
        else
            pstr = str;
        end
        Text = sprintf('%s%20s : %-30s\n', Text, strtrim(fn{k}), pstr);
        scanText{m, 1} = fn{k};
        scanText{m, 2} = pstr;
        m = m + 1;
    end
    scanText{m, 1} = '----------------------------------';
    scanText{m, 2} = '----------------------------------';
    m = m + 1;
    T = '--------------------------------------------';
    Text = sprintf('%s\n%s\n', Text, T);
    disp(Text)
end
%scanText = reshape(scanText, numel(scanText)/2, 2);

if isNew
uitable(hPanel1,...
    'data',scanText,...
    'Position',[10 10 panelSize(3)-20 panelSize(4)-60],...
    'ColumnName','',...
    'ColumnWidth', {100, 200},...
    'RowName','',...
    'Tag','figSAXSLeeshowscan_edit2');

else
    tableHandle = findobj(h, 'type', 'uitable');
    set(tableHandle, 'data', scanText);
end
% jscrollpane = findjobj(tableHandle);
% jTable = jscrollpane.getViewport.getView;
% 
% cellStyle = jTable.getColumnStyleAt(0);
% cellStyle.setHorizontalAlignment(cellStyle.RIGHT);
% 
% % Table must be redrawn for the change to take affect
% jTable.repaint;


%setappdata(h,'scanText',scanText);
%hPopupmenu1 = findobj(h,'Tag','figSAXSLeeshowscan_popupmenu1');
%hEdit2      = findobj(h,'Tag','figSAXSLeeshowscan_edit2');
%set(hPopupmenu1,'String',scanHead,'value',1);
%set(hEdit2,'String',scanText,'HorizontalAlignment','left');


%=================================================================
% --- figure resizefcn function
%=================================================================
function resizefcn(varargin)
h = gcbo;
p1 = get(h,'Position');
panelSize = [10 60 p1(3)-20 p1(4)-70];
try
    set(findobj(h,'tag','figSAXSLeeshowscan_panel1'),'position',panelSize);
    set(findobj(h,'tag','figSAXSLeeshowscan_popupmenu1'),'position',[10 panelSize(4)-40 panelSize(3)-20 20]);
    set(findobj(h,'tag','figSAXSLeeshowscan_edit2'),'position',[10 10 panelSize(3)-20 panelSize(4)-60]);
    set(findobj(h,'tag','figSAXSLeeshowscan_pushbuttonRefresh'),'position',[p1(3)-20-160 20 80 25]);
    set(findobj(h,'tag','figSAXSLeeshowscan_pushbuttonClose'),'position',[p1(3)-10-80 20 80 25]);
catch
end
