function SAXSLeesetting(varargin)
% GUI for SAXSLee settings 

hFigSAXSLee = findobj('Tag','SAXSLee_Fig');    % handle of the mother figure (SAXSLee)
settings = getappdata(hFigSAXSLee,'settings');
icons = load('SG_icons.mat');

% --- figure layout
p0      = get(hFigSAXSLee,'position');    % main figure position
p1(3)   = 480;              % p1 is the setting figure position
p1(4)   = 230;
p1(1)   = p0(1)+p0(3)/2-p1(3)/2;
p1(2)   = p0(2)+p0(4)/2-p1(4)/2;
h = figure(...
    'Units','pixels',...
    'MenuBar','none',...
    'Units','pixels',...
    'Name','Spec Reader Settings',...
    'NumberTitle','off',...
    'IntegerHandle','off',...
    'Position',p1,...
    'HandleVisibility','callback',...
    'Tag','figSAXSLeeSettings',...
    'Resize','off',...
    'WindowStyle','modal',...
    'UserData',[]);
panelSize = [10 60 p1(3)-20 p1(4)-70];
hPanel1 = uipanel(...
    'Parent',h,...
    'BackgroundColor',get(h,'Color'),...
    'Title','Settings',...
    'Units','pixels',...
    'Position',panelSize);
hText1 = uicontrol(...
    'Parent',hPanel1,...
    'Style','text',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(h,'Color'),...
    'Position',[10 panelSize(4)-35 panelSize(3)*2/3-10 15],...
    'String','Data Average Method');
hPopupmenu1a = uicontrol(...
    'Parent',hPanel1,...
    'Style','popupmenu',...
    'HorizontalAlignment','left',...
    'BackgroundColor','w',...
    'Position',[panelSize(3)*2/3 panelSize(4)-35 panelSize(3)/3-10 20],...
    'String','Goldaverage|SAXSimageviewer(default)',...
    'Value',settings.average.mode);

%hEdit1 = uicontrol(...
%    'Parent',hPanel1,...
%    'Style','edit',...
%    'BackgroundColor','w',...
%    'Position',[panelSize(3)*2/3 panelSize(4)-35 panelSize(3)/3-27 20],...
%    'String',num2str(settings.wavelength,15),...
%    'HorizontalAlignment','left');
%hPushbutton1 = uicontrol(...
%    'Parent',hPanel1,...
%    'Style','pushbutton',...
%    'CDATA',icons.calculator,...
%    'Position',[panelSize(3)-24 panelSize(4)-35 14 18],...
%    'callback','engwav');
hText2 = uicontrol(...
    'Parent',hPanel1,...
    'Style','text',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(h,'Color'),...
    'Position',[10 panelSize(4)-58 panelSize(3)*2/3-10 15],...
    'String','Unix command for goldaverage');
hEdit2 = uicontrol(...
    'Parent',hPanel1,...
    'Style','edit',...
    'BackgroundColor','w',...
    'Position',[panelSize(3)*2/3 panelSize(4)-58 panelSize(3)/3-10 20],...
    'String', settings.averageCmd,...
    'HorizontalAlignment','left');
hText3 = uicontrol(...
    'Parent',hPanel1,...
    'Style','text',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(h,'Color'),...
    'Position',[10 panelSize(4)-81 panelSize(3)*2/3-10 15],...
    'String','subdir for the averaged:');
hEdit3 = uicontrol(...
    'Parent',hPanel1,...
    'Style','edit',...
    'HorizontalAlignment','left',...
    'BackgroundColor','w',...
    'Position',[panelSize(3)*2/3 panelSize(4)-81 panelSize(3)/3-10 20],...
    'String',settings.averageDir);
hText3a = uicontrol(...
    'Parent',hPanel1,...
    'Style','text',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(h,'Color'),...
    'Position',[10 panelSize(4)-104 panelSize(3)*2/3-20 15],...
    'String','Auto averaging method');
hPopupmenu3a = uicontrol(...
    'Parent',hPanel1,...
    'Style','popupmenu',...
    'HorizontalAlignment','left',...
    'BackgroundColor','w',...
    'Position',[panelSize(3)*2/3 panelSize(4)-104 panelSize(3)/3-10 20],...
    'String','Spec file (default)|Update directories',...
    'Value',settings.automethod);
hText3b = uicontrol(...
    'Parent',hPanel1,...
    'Style','text',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(h,'Color'),...
    'Position',[20 panelSize(4)-127 panelSize(3)*2/3-20 15],...
    'String','For option 2, Format of images');
hEdit3b = uicontrol(...
    'Parent',hPanel1,...
    'Style','Edit',...
    'HorizontalAlignment','left',...
    'BackgroundColor','w',...
    'Position',[panelSize(3)*2/3 panelSize(4)-127 panelSize(3)/3-10 20],...
    'String',settings.imageListString);
hText4 = uicontrol(...
    'Parent',hPanel1,...
    'Style','text',...
    'HorizontalAlignment','left',...
    'BackgroundColor',get(h,'Color'),...
    'Position',[10 panelSize(4)-150 panelSize(3)*2/3-10 15],...
    'String','Scan Monitor Period: (Sec)');
hEdit4 = uicontrol(...
    'Parent',hPanel1,...
    'Style','edit',...
    'BackgroundColor','w',...
    'Position',[panelSize(3)*2/3 panelSize(4)-150 panelSize(3)/3-10 20],...
    'String',num2str(settings.monitorPeriod,15),...
    'HorizontalAlignment','left');

hPushbuttonOK = uicontrol(...
    'Parent',h,...
    'Style','pushbutton',...
    'String','OK',...
    'Position',[p1(3)-180 20 80 25],...
    'callback',{@SAXSLeesettings_OKRequestFcn,hFigSAXSLee,h,hPopupmenu1a,hEdit2,hEdit3,hPopupmenu3a,hEdit3b,hEdit4});
hPushbuttonCancel = uicontrol(...
    'Parent',h,...
    'Style','pushbutton',...
    'String','Cancel',...
    'Position',[p1(3)-90 20 80 25],...
    'Callback',@SAXSLeesettings_CloseRequestFcn);


%================================================================
% --- SAXSLeesettings close function
%================================================================
function SAXSLeesettings_CloseRequestFcn(hObject,eventdata)
delete(gcf);
return;


%================================================================
% --- SAXSLeesettings close function
%================================================================
function SAXSLeesettings_OKRequestFcn(hObject,eventdata,hFigSAXSLee,h,hPopupmenu1a,hEdit2,hEdit3,hPopupmenu3a,hEdit3b,hEdit4)
settings = getappdata(hFigSAXSLee,'settings');
%wavelength = str2double(get(hEdit1,'string'));
%if isnan(wavelength) | wavelength<=0
%    uiwait(msgbox('Invalid wavelength!','Settings Error','error','modal'));
%    return;
%end
%settings.wavelength = wavelength;
%footprintAngle = str2double(get(hEdit2,'string'));
%if isnan(footprintAngle) | footprintAngle<=0
%    uiwait(msgbox('Invalid foot print angle!','Settings Error','error','modal'));
%    return;
%end
%settings.footprintAngle = footprintAngle;
settings.average.mode = get(hPopupmenu1a,'value');
if settings.average.mode == 1;
    settings.averageCmd = (get(hEdit2,'string'));
end
settings.averageDir = (get(hEdit3,'string'));
settings.automethod = get(hPopupmenu3a,'value');
settings.imageListString = (get(hEdit3b,'string'));
%settings.merge.mode = get(hPopupmenu3a,'value');
%settings.merge.interpMethod = get(hPopupmenu3b,'value');
settings.merge.mode = 2;
settings.merge.interpMethod = 1;
monitorPeriod = str2double(get(hEdit4,'string'));
if isnan(monitorPeriod) | monitorPeriod<0.1
    uiwait(msgbox('Invalid monitor period!','Settings Error','error','modal'));
    return;
end
settings.monitorPeriod = monitorPeriod;

hFigSAXSLee = findall(0,'Tag','SAXSLee_Fig');
hPopupmenuX = findobj(hFigSAXSLee, 'tag', 'SAXSLee_PopupmenuX');
try
    setall = evalin('base', 'setall');
    setall{get(hPopupmenuX, 'value')}.settings = settings;
    assignin('base', 'setall', setall)
    %setappdata(hFigSAXSLee,'settings', settings);
    %assignin('base', 'settings', settings)
    %setappdata(hFigSAXSLee,'setall');
catch
end

setappdata(hFigSAXSLee,'settings',settings);

delete(h);
return;