function [y, par] = macroLineCut(graphHandle, bodyFname, FN, ExtFname)
% function [y, qp, qz, par] = macroLineCut(graphHandle(or struct: par), bodyFname, FN, ExtFname)
% graphHandle : handle of graph containing multiple line cuts generated by imgAnalysis.m
% ex) filename =  'rw022504i14.00001.ccd' and 'rw022504i14.00100.ccd'
%       bodyFname = 'rw022504i14.00'
%       FN = [1, 100];
%       ExtFname = '.ccd'
% 
if ~isstruct(graphHandle)
    if ishandle(graphHandle)
        [x, y, z] = getlinefig(graphHandle);
    end
else
    z = graphHandle;
end
saxs = getgihandle;
y=[];
mFN = length(num2str(max(FN)));
pixeltocut = [z.X, z.Y];

for i = 1:numel(FN)
    num = num2str(FN(i));
    while length(num) < mFN
        num = ['0', num];
    end

    Fname = [bodyFname, num, ExtFname];
    %T = imread(Fname);T = double(T);
    [kk, T] = openccdfile(Fname, saxs);
%    for j=1:numel(z)
%        y(:, i, j) = interp2(T, z(j).X, z(j).Y)';
%    end
    cut = linecut(T, pixeltocut);
    i
    y(:,i) = cut;
end

%for j=1:numel(z)
%    qp(:, j) = z(j).qp';
%    qz(:, j) = z(j).qz';
%end

par = z;