function [y, qp, qz, par] = macroLineCut(graphHandle, bodyFname, FN, ExtFname)
% function [y, qp, qz, par] = macroLineCut(graphHandle(or Struct: par), bodyFname, FN, ExtFname)
% graphHandle : handle of graph containing multiple line cuts generated by imgAnalysis.m
% ex) filename =  'rw022504i14.00001.ccd' and 'rw022504i14.00100.ccd'
%       bodyFname = 'rw022504i14.00'
%       FN = [1, 100];
%       ExtFname = '.ccd'
% 
if ~isstruct(graphHandle)
    if ishandle(graphHandle)
        [x, y, z] = getlinefig(graphHandle);
    end
else
    z = graphHandle;
end

y=[];
mFN = length(num2str(max(FN)));

for i = 1:prod(size(FN))
    num = num2str(FN(i))
    while length(num) < mFN
        num = ['0', num];
    end

    Fname = [bodyFname, num, ExtFname];
    T = goldopen(Fname);T = double(T);
    for j=1:prod(size(z))
        y(:, i, j) = interp2(T, z(j).X, z(j).Y)';
    end
    size(y)
    % ======================== background substraction....
%    t = (T(200:340, 600:700));
%    t = reshape(t, 1, prod(size(t)));
%    t(find( t == Inf)) = [];
%    y(:, i) = y(:, i) - mean(t);
    % ====================================================
end

for j=1:prod(size(z))
    qp(:, j) = z(j).qp';
    qz(:, j) = z(j).qz';
end

par = z;