function inMoleculedraw(latticep, molp, ang)
% function inMoleculedraw(latticep, molp, ang)
%   latticep = [axis, baxis], ex [5.35, 8.9];
%   molp = [length, width];
%   ang = euler angle. ex[10, 10, 0];(tilt angle, azimuthal angle, rotation angle)
% function to show the in-plane crystal structure.
% parameters are the same used for the function indiffrac.m
% Byeongdu Lee
% Oct. 17. 2004

d = molp(1);w = molp(2);
a = latticep(1);b = latticep(2);
[x, y, z] = cylinder(1, 20);
x = x*w;
z = z*d;
y = y*w/10;

t1 = [x(1, :); y(1, :); z(1, :)];
t2 = [x(2, :); y(2, :); z(2, :)];

m1 = eulerrot(t1, ang(1, :));
m2 = eulerrot(t2, ang(1, :));
x = [m1(1, :); m2(1, :)];
y = [m1(2, :); m2(2, :)];
z = [m1(3, :); m2(3, :)];

figure;%mesh(x, y, z);hold on
surf(x, y, z, 'edgecolor', 'r', 'facecolor', 'r', 'facelighting','phong');hold on
for i=0:1
    for j=0:1
        if ~((i==0)&(j==0))
            x2 = x+a*i;
            y2 = y+b*j;
            z2 = z;
            %mesh(x2, y2, z2)
            surf(x2, y2, z2, 'edgecolor', 'r', 'facecolor', 'r', 'facelighting','phong')
        end
    end
end

if ~(length(ang(:, 1) == 2))
    %mesh(x+a/2, y+b/2, z);
    surf(x+a/2, y+b/2, z, 'edgecolor', 'r', 'facecolor', 'r', 'facelighting','phong')
else
    m1 = eulerrot(t1, ang(2, :));
    m2 = eulerrot(t2, ang(2, :));
    x = [m1(1, :); m2(1, :)];
    y = [m1(2, :); m2(2, :)];
    z = [m1(3, :); m2(3, :)];
    %mesh(x+a/2, y+b/2, z);
    surf(x+a/2, y+b/2, z, 'edgecolor', 'r', 'facecolor', 'r', 'facelighting','phong')
end
plot3([0, a], [0, 0], [0, 0]);
plot3([0, 0], [0, b], [0, 0]);
plot3([0, 0], [0, 0], [0, d]);

plot3([a, a], [0, 0], [0, d]);
plot3([0, 0], [b, b], [0, d]);
plot3([a, a], [b, b], [0, d]);

plot3([0, a], [b, b], [0, 0]);
plot3([0, a], [0, 0], [d, d]);
plot3([0, a], [b, b], [d, d]);

plot3([a, a], [0, b], [0, 0]);
plot3([0, 0], [0, b], [d, d]);
plot3([a, a], [0, b], [d, d]);
view([0 0 90]);

set(gca, 'DataAspectRatio' , [1  1 1]);

colormap(cool(100))
%lighting phong;
%light;      
lightangle(90,120);
