function [sumFq, Q] = indiffrac2(qx, qy, qz, latticep, molp, ang)
% function [Fq, Q] = indiffrac2(qx, qy, qz, latticep, molp, ang)
%   reflec = [h, k], ex [1, 1];
%   latticep = [axis, baxis], ex [5.35, 8.9];
%   molp = [length, width];
%   ang = euler angle. ex[10, 10, 0];(tilt angle, azimuthal angle, rotation angle)
% function to calculate peak position and its amplitude.
% parameters are the same used for the function inMoleculedraw.m
% inMoleculedraw.m function will draw the real space structure.
% Byeongdu Lee
% Oct. 17. 2004

%h = hk(1);k = hk(2);
d = molp(1);w = molp(2);
a = latticep(1);b = latticep(2);
s1 = prod(size(qx));
s2 = prod(size(qy));
s3 = prod(size(qz));
S = [s1, s2, s3];
k = find(S == max(S));

switch k
case 1
    qy = qy*ones(size(qx));
    qz = qz*ones(size(qx));
case 2
    qx = qx*ones(size(qy));
    qz = qz*ones(size(qy));
case 3
    qx = qx*ones(size(qz));
    qy = qy*ones(size(qz));
end

%qx = 2*pi/a*h;
%qy = 2*pi/b*k;
%qz = 0;

ang = deg2rad(ang);
sumFq = [];
Fq = [];
for i=1:length(ang(:,1));
    %qz = sin(ang(1))*(cos(ang(2))*qx + sin(ang(2))*qy) + cos(ang(1))*qz;
    th = ang(i, 1);ph=ang(i, 2);xi=ang(i, 3);
%    qz = -sin(th)/cos(th)*(cos(ph)*qx + sin(ph)*qy);
%    th = th;ph = -ph;xi = -xi;
    Q = [qx;qy;qz];

    Rinv = [cos(th)*cos(ph)*cos(xi)-sin(ph)*sin(xi),cos(th)*sin(ph)*cos(xi)+cos(ph)*sin(xi),-sin(th)*cos(xi);
        -cos(th)*cos(ph)*sin(xi)-sin(ph)*cos(xi),-cos(th)*sin(ph)*sin(xi)+cos(ph)*cos(xi),sin(th)*sin(xi);
        sin(th)*cos(ph),sin(th)*sin(ph),cos(th)];
    q = Rinv*Q;
    Fq(i, :) = sinc(q(1, :)*w/2/pi).*sinc(q(3, :)*w/2/pi);
%    sin(q(1)*w/2+eps)./(q(1)*w/2 + eps).*sin(q(3)*d/2+eps)./(q(3)*d/2+eps)
end
if length(Fq(:, 1)) == 2
    sumFq = Fq(1, :) + Fq(2, :).*cos(qx*a/2 + qy*b/2);
else
    sumFq = Fq(1, :) + Fq(1, :).*cos(qx*a/2 + qy*b/2);
end