function [tth, name, pname, p] = monoclinic(x,p,flag)

name = 'monoclinic';
pname = 'cell parameter';

h = x(:,1);
k = x(:,2);
l = x(:, 3);
a = p(1);
b = p(2);
c = p(3);
al = p(4);
be = p(5);
ga = p(6);

al = deg2rad(al);
be = deg2rad(be);
ga = deg2rad(ga);

inv_d_sqr = 1./sin(be).^2*(h.^2/a.^2 + k.^2.*sin(be).^2./b.^2 + l.^2./c.^2 - 2*h.*l.*cos(be)./a./c);
d = 1./sqrt(inv_d_sqr);

q = 2.*pi./d;

tth = rad2deg(asin(1.54./2./d)).*2;