function [a, q, intensity] = load_data(str, crop)
%[a, q, intensity] = load_data(str, crop)
a = dir(str);
intensity = [];
q = [];
if isempty(a)
    disp('NO files found');
    return
end
for i=1:numel(a)
    if a(i).bytes > 201586
        disp(sprintf('the file %s might not be an ascii file', a(i).name))
    else
        [h, a(i).data] = hdrload(a(i).name);
        if nargin > 1
            a(i).data = a(i).data(crop,:);
        end
        
        try
            intensity = [intensity, a(i).data(:,2)];
            q = a(i).data(:,1);
        catch
            disp(sprintf('there is a problem in %s', a(i).name))
            interpintensity = interp1(a(i).data(:,1), a(i).data(:,2), q);
            intensity = [intensity, interpintensity];
        end
    end
end
