function [xx, yy, zz] = bingrid(x, y, z, binsize)
x = x(:);
y = y(:);
z = z(:);
xc = sum(x)/numel(x);
yc = sum(y)/numel(y);
zc = sum(z)/numel(z);
x = x-xc;y = y-yc;z = z-zc;
d = sqrt(x.^2+y.^2+z.^2);
dmax = max(d);
binnumber = round(dmax/binsize);
disp(sprintf('Number of bin is %i\n', (binnumber*2+1).^3))
disp(sprintf('Recommended qmax is %f\n', 2*pi/binsize))

binx = -binnumber:binnumber;
xx = [];yy = []; zz = [];
cnt = 1;sdigit = 1;
for i=1:numel(binx)
    for j=1:numel(binx)
        for k=1:numel(binx)
            bxl = (binx(i)-1/2)*binsize;
            bxh = (binx(i)+1/2)*binsize;
            byl = (binx(j)-1/2)*binsize;
            byh = (binx(j)+1/2)*binsize;
            bzl = (binx(k)-1/2)*binsize;
            bzh = (binx(k)+1/2)*binsize;
            xp = find(x>bxl & x<=bxh);
            yp = find(y>byl & y<=byh);
            zp = find(z>bzl & z<=bzh);
            ingrid = intersect(intersect(xp, yp), zp);
            if ~isempty(ingrid)
                xx = [xx, sum(x(ingrid))/numel(ingrid)];
                yy = [yy, sum(y(ingrid))/numel(ingrid)];
                zz = [zz, sum(z(ingrid))/numel(ingrid)];
            end
            cnt = cnt+1;
            percentdone = fix(cnt/numel(binx)^3*100);
            if  percentdone == sdigit
                disp([num2str(percentdone),' percent done'])
                sdigit = sdigit + 1;
            end
        end
    end
end