function Sq1 = debyef2(q, x, y, z)
% Calculate the structure factor (Sq) = iq + 1 using the Debye formulae
% It will calculate Sq using all atoms without any resolution reduction.
% p(r) function will be first calculated.
% for the faster version see debyepr.m, which use resolution...
% Byeongdu Lee.
coord = [x(:), y(:), z(:)];
ddl = distNzero_(coord);
r1 = unique(ddl);
pr1 = histc(ddl, r1);
Sq1 = debyef0(q, r1, pr1)/numel(x)+1;