#include "mex.h"
#include <math.h>
#include <time.h>

double sinc(double x)
{
if (x==0) return 1;
else return sin(x)/x;
}

void mexFunction(int nlhs,       mxArray *plhs[],
		 int nrhs, const mxArray *prhs[])
{
    /* Declare variables */ 
    mwSize atm_len;
    mwSize q_pnt;
    mxArray *p;
/*    double *r_jk;*/
    double *pind;
    double *q, *atm, *x, *y, *z;
    double r_jk=0.0;
    long m, j, k, cnt;
    clock_t start, end;
    double elapsed;
    
    /* Check for proper number of input and output arguments */    
    if (nrhs != 5) {
	mexErrMsgTxt("Five input arguments required. q, atm, x, y, z");
    } 
    if (nlhs > 1){
	mexErrMsgTxt("Too many output arguments.");
    }
    
    /* Check data type of input argument */
    if (!(mxIsDouble(prhs[0]))) {
      mexErrMsgTxt("Input array must be of type double.");
    }
    
    /* Get the number of elements in the input argument */
    /* input: q, S, dl, ul, delta, w
     output : q
    elements=mxGetNumberOfElements(prhs[0]);
    Get the data */
    q = mxGetPr(prhs[0]);
    atm = mxGetPr(prhs[1]);
    x = mxGetPr(prhs[2]);
    y = mxGetPr(prhs[3]);
    z = mxGetPr(prhs[4]);
    atm_len = mxGetNumberOfElements(prhs[1]);
    q_pnt = mxGetNumberOfElements(prhs[0]);
    
    /* Get the number of dimensions in the input argument. Allocate the
       space for the return argument */
    plhs[0]=mxCreateDoubleMatrix(q_pnt,1,mxREAL);
    pind=mxGetPr(plhs[0]);
    p=mxCreateDoubleMatrix(atm_len*(atm_len-1)/2,1,mxREAL);
/*    r_jk=mxGetPr(p);*/
	
    /* Fill in the indices to return to MATLAB. This loops through the
     * elements and checks for non-zero values. If it finds a non-zero
     * value, it then calculates the corresponding MATLAB indice and
     * assigns them into the output array.  The 1 is added to the
     * calculated indice because MATLAB is 1 based and C is zero
     * based. */
    cnt = 0;
/*    start = clock();
    
    for (j=0;j<atm_len-1;j++) {
        for (k=j+1;k<atm_len;k++) {
            r_jk[cnt] = sqrt((x[j]-x[k])*(x[j]-x[k]) + (y[j]-y[k])*(y[j]-y[k]) + (z[j]-z[k])*(z[j]-z[k]));
            cnt++;
        }
    }
    end = clock();
    elapsed = ((double)(end-start))/ CLOCKS_PER_SEC;
 */
    /*printf("time elapsed is %f\n", elapsed);*/
    
    for (m=0;m<q_pnt;m++) {
        cnt = 0;
        pind[m] = 0.0;
        for (j=0;j<atm_len-1;j++) {
            pind[m] += atm[j]*atm[j];
            for (k=j+1;k<atm_len;k++) {
/*                r_jk = sqrt((x[j]-x[k])*(x[j]-x[k]) + (y[j]-y[k])*(y[j]-y[k]) + (z[j]-z[k])*(z[j]-z[k]));
                pind[m] += 2.0*atm[j]*atm[k]*sinc(q[m]*r_jk); */
                r_jk = sqrt((x[j]-x[k])*(x[j]-x[k]) + (y[j]-y[k])*(y[j]-y[k]) + (z[j]-z[k])*(z[j]-z[k]));
/*                pind[m] += 2.0*atm[j]*atm[k]*sinc(q[m]*r_jk[cnt]);
                cnt++;  */
                pind[m] += 2.0*atm[j]*atm[k]*sinc(q[m]*r_jk);
            }
        }
/*    	pind[m] += atm[q_pnt-1]*atm[q_pnt-1]; */
	}
}
