function Sq1 = debyepr0(q, x, y, z, atm)
% Calculate the structure factor (Sq) = iq + 1 using the Debye formulae
% It will calculate Sq using all atoms without any resolution reduction.
% p(r) function will be first calculated.
% for the faster version see debyepr.m, which use resolution...
% Byeongdu Lee.
coord = [x(:), y(:), z(:)];
if nargin > 4
    [r1, pr1] = distNzero1(coord, 0, atm);
    Sq1 = debyef0(q, r1, pr1)/sum(atm.^2)+1;
else
    [r1, pr1] = distNzero1(coord, 0);
    Sq1 = debyef0(q, r1, pr1)/numel(x)+1;
end