function [r, pr] = distNzero1(coord, resolution, atm)
% [r, pr] = distNzero1(coord, resolution, atm)
% coord : positions of atoms in Nx3 matrix, [x1, y1, z1;....;xN, yN, zN].
% resolution: size of bins for the distance r.
% atm: scattering factor of the atoms, Nx1 array.

if nargin == 1
    resolution = 100;
end
if resolution > 0
    coord = round(coord*resolution);
    if nargin == 3
        [r,pr] = distNzero1_(coord, atm);
    else
        [r,pr] = distNzero1_(coord);
    end
    r = r/resolution;
elseif resolution == 0
    if nargin == 3
        [ddl, ff] = distNzero1_(coord,atm);    
        [r, indx] = unique(ddl);
        nff = ff(indx);
        pr = histc(ddl, r);
        if numel(r) ~= numel(ff)
            n0indx = find(pr ~= 1);
            for i=1:numel(n0indx)
                t = ddl == r(n0indx(i));
                nff(n0indx(i)) = sum(ff(t));
            end
        end
        pr = pr.*nff;
    else
        ddl = distNzero(coord);    
        r = unique(ddl);
        pr = histc(ddl, r);
    end
end