#include "mex.h"
#include <math.h>
#include <time.h>
#define MAXARRAY 10000000

double sinc(double x)
{
if (x==0) return 1;
else return sin(x+0.000001)/(x+0.000001);
}

void mexFunction(int nlhs,       mxArray *plhs[],
		 int nrhs, const mxArray *prhs[])
{
    /* Function to calculate g(r) to i(q), the interference function */
    /* Declare variables */
    int q_pnt;
    long gr_pnt;
    double *q, *r;
    double *gr;
    double *pind;
    double np;
    long m, j, k, i;
    long kk;
    double pi = 3.14159265;
    
    /* Get the data */
    q = mxGetPr(prhs[0]);
    r = mxGetPr(prhs[1]);
    gr = mxGetPr(prhs[2]);
    np = mxGetScalar(prhs[3]);
            
    /* Check for proper number of input and output arguments */    
    if (nrhs != 4) {
	mexErrMsgTxt("three input arguments required. q, r, gr, and np");
    } 
    if (nlhs > 1){
	mexErrMsgTxt("Too many output arguments.");
    }
    /* Check data type of input argument */
    if (!(mxIsDouble(prhs[0]))) {
      mexErrMsgTxt("Input array must be of type double.");
    }
    
    /* Get the number of elements in the input argument */

    q_pnt = mxGetNumberOfElements(prhs[0]);
    gr_pnt = mxGetNumberOfElements(prhs[1]);
    
    plhs[0]=mxCreateDoubleMatrix(q_pnt,1,mxREAL);
    pind=mxGetPr(plhs[0]);
    
    for (m=0;m<q_pnt;m++) {
        pind[m] = 0;
        for (j=0;j<gr_pnt;j++) {
            pind[m] += (gr[j]-1)*4*pi*r[j]*r[j]*sinc(q[m]*r[j]);
        }
    }
}