function [y, name, pnames, pin]=logn(x,p, flag)
% gauss     : lognormal distribution
% [y, {name, pnames, pin}]=logn(x,p, {flag}) 
% MFIT Gaussian fitting function
% p = [r0, sig]

% Author:  MZ <mzinkin@sghms.ac.uk>
% Description: Gaussian

if nargin==2;
    r0 = p(1);
    sig = p(2);
    A = p(3);
    y = A*logndist(r0, sig, x);
else
	y=[];
	name='lognormal';
	pnames=str2mat('r0','sig', 'A');
	if flag==1, pin=[14, 0.25, 1]; else pin = p; end
end
