function [pospx, pospy] = diffusionTKurs_rand (numofparticle, numofsteps, xMax, yMax, steps, display, Pro_changeparticledirection)

% DIFFUSIONTKURS(numofparticle,numofsteps,XMAX,YMAX) draws the path of one
% diffusing particle. For more information see diffusionT.m.
%
% DIFFUSIONTKURS(numofparticle,numofsteps) uses xMax = 40, yMax = 30.
%
% DIFFUSIONTKURS uses numofparticle = 20, numofsteps = 100 in addition.

% This file was generated by students as a partial fulfillment 
% for the requirements of the course "Fractals", Winter term
% 2004/2005, Stuttgart University.	

% Author : Fabian Hansch, Stefanie Schetter
% Date   : Dec 2004
% Version: 1.0
if nargin < 7
    Pro_changeparticledirection = 1;  % probability to change direction of particles..
end

% default setting
if (nargin < 6)
    display = 1;
end

if (nargin < 5)
    steps = 0.05;
end

if (nargin < 4)
    xMax = 40;
    yMax = 30;
end
if (nargin < 2)
    numofparticle = 20;
    numofsteps = 100;
end

Position = zeros(2, numofparticle);
moveangle = zeros(1, numofparticle);  % angle (direction)
% the variable for the path
Kurs = zeros(2, numofsteps); % save path to Kurs.....
% initialising the particles (random starting points)
for i = 1:numofparticle
    moveangle(1, i) = rand(1)*2*pi;
    Position(1, i) = rand(1)*xMax;
    Position(2, i) = rand(1)*yMax;
end;

if (display == 1)
    clf;
    axis square; axis equal;
end
%axis image;

% length of a straight move
Nstraight = 0;
%
%

for i = 1:numofsteps  % interation
    if mod(i, 10) == 0
        Pro_cd = Pro_changeparticledirection;
    else
        Pro_cd = Pro_changeparticledirection;
    end
    
    if display == 1
        hold off;
        plot([0, 0, xMax, xMax, 0], [0, yMax, yMax, 0, 0], 'b-');
        hold on;
        plot([-10, -10, xMax+10, xMax+10, -10], [-10, yMax+10, yMax+10, -10, -10], 'b-');
        axis tight;
    end
    % remembering the path
    Kurs(1, i) = Position(1, 1);
    Kurs(2, i) = Position(2, 1);
    for j = 1:numofparticle
        if display == 1
            if (j == 1)
                % plot the special particle
                plot(Position(1, j), Position(2, j), 'r.');
            else
                % plot all other particles
                plot(Position(1, j), Position(2, j), 'b.');
            end;
        end
        
       for t = 1:numofparticle
% ============newly added. by BLee
           straightornot = rand(1);
           if Nstraight == 0
               moveangle(1, j) = rand(1)*2*pi;
               Nstraight = Nstraight + 1;
           elseif abs(straightornot) <= Pro_cd
               moveangle(1, j) = rand(1)*2*pi;
               Nstraight = 1;
           else
               Nstraight = Nstraight + 1;
           end
           
% ============================

           % is there another particle that hits the current one?
           if (t ~= j) & (sqrt((Position(1, j)-Position(1, t))^2 + (Position(2, j)-Position(2, t))^2))<=3

               if (Position(1, t) ~= Position(1, j))
                  Lot = atan((Position(2, t)-Position(2, j))/(Position(1, t)-Position(1, j)));
                else
                  Lot = pi/2;
               end;
               alpha1 = moveangle(1, j);
               alpha2 = moveangle(1, t);
               moveangle(1, j) = mod(2*Lot - alpha2, 2*pi);
               moveangle(1, t) = mod(2*Lot - alpha1, 2*pi);
           end;
       end;
       % calculating the new positions
       Position(1, j) = Position(1, j) + steps*cos(moveangle(1, j));
       Position(2, j) = Position(2, j) + steps*sin(moveangle(1, j));
       
       % is there a wall?
       if (Position(1, j) >= xMax)
           moveangle(1, j) = pi - moveangle(1, j);
           Position(1, j) = xMax;
       end;
       if (Position(1, j) <= 0)
           moveangle(1, j) = pi - moveangle(1, j);
           Position(1, j) = 0;
       end;
       if (Position(2, j) >= yMax)
           moveangle(1, j) = 2*pi - moveangle(1, j);
           Position(2, j) = yMax;
       end;
       if (Position(2, j) <= 0)
           moveangle(1, j) = 2*pi - moveangle(1, j);
           Position(2, j) = 0;
       end;
       moveangle(1, j) = mod(moveangle(1, j), 2*pi);
    pospx(i,j) = Position(1,j);
    pospy(i,j) = Position(2,j);
    end;
    
    if display == 1
        pause (1/24);
    end
end;

if display == 1
    pause;

    clf;
    x = 1:numofsteps;
    hold on;
    % plotting the path
    plot([0, 0, xMax, xMax, 0], [0, yMax, yMax, 0, 0], 'b-');
    hold on;
    plot([-10, -10, xMax+10, xMax+10, -10], [-10, yMax+10, yMax+10, -10, -10], 'b-');
    hold on;
    plot(Kurs(1, x), Kurs(2, x), 'r-');
    %axis tight;
    hold off;
end