function in = inPolyhedron2(obj, point)
% function [ output_args ] = inPolyhedron2(obj, point)
%   obj.vertices, point in 3D.
%
% Byeongdu Lee, 2012. 11. 19
% http://www.mathworks.com/matlabcentral/newsreader/view_thread/254509
in = zeros(size(point,1),1);
if isfield(obj, 'stellate')
    in1 = inorout(obj.original.vertices, point);
    in = in | in1;
    for i=1:numel(obj.stellate)
        in1 = inorout(obj.stellate{i}.vertices, point);
        if obj.stellateh > 0
            in = in | in1;
        else
            in = in & ~in1;
        end
    end
else
    if ~isstruct(obj)
        obj2.vertices = obj;
    else
        obj2 = obj;
    end
    in = inorout(obj2.vertices,point);
end
    
        
end


function output_args=inorout(V,pts)

tri = delaunay(V);
%tri = obj.faces;
tn = tsearchn(V, tri, pts);
output_args = isfinite(tn);

end

