function seq = planeconstruct(v, N)
% when a number of points that belong to a plane in 3D space are given,
% this program find a sequence to make a polygon

    cm = mean(v);
if nargin == 1
    N = planeNormal([v(1, :), v(2, :)-v(1, :), v(3, :)-v(1, :)]);
else
    PT2 = projPointOnPlane(N, [v(1, :), v(2,:)-v(1, :), v(3,:)-v(1, :)]);
    N = N-PT2;
end
    seq = 1;
    v0 = v;
    seqV = 1:numel(v(:,1));
    v(1, :) = [];
    seqV(1) = [];
    while ~isempty(v)
        ang0 = 0;
        seqN = -1;
        for i=1:size(v, 1)
            if size(v,1) == 1
                seqN = 1;
            else
                % finding a neighbor point along anti-clock wise direction
                % around the N vector.
                % 
                v2 = v(i, :)-v0(seq(end), :);
                vc = cm-v0(seq(end), :);
                if dot(N, cross(v2, vc)) > 0
                    ang = angle2vect2(v2, vc);
                    if abs(ang) > ang0
                        seqN = i;
                        ang0 = abs(ang);
                    end
                end
            end
        end
        if seqN >= 1
            seq = [seq, seqV(seqN)];
            v(seqN, :) = [];
            seqV(seqN) = [];
        else
            return;
        end
    end