function [hd, rvc] = showhkl2(h,k,l,mat)
% function [hd, rvc] = showhkl2(h,k,l,mat)
% showhkl(h, k, l) or showhkl(h, k, l, mat)
if nargin < 4
    mat = [1,0,0;0,1,0;0,0,1];
end
a = [1,0,0];
b = [0,1,0];
c = [0,0,1];
vec = h*a+k*b+l*c;
A = [1,0,0;
    -1,0,0;
    0,1,0;
    0,-1,0;
    0,0,1;
    0,0,-1; 
    vec; 
    -1*vec];

dx = floor(norm(vec)*sqrt(3));k=1;
for d=-dx:dx
    [h, mm] = shows(A, vec, d, mat);
    if ~isempty(h)
        hd(k) = h;
        rvc{k} = mm;
        k = k+1;
    end
end

function [hd, rvc] = shows(A, vec, d, mat)
b = [1;
    0;
    1;
    0;
    1;
    0;
    d;
    -1*(d+0.001)];
V = round(con2vert(A, b)*100)/100;
rvc = reducehkl(V);
%kk = sum(abs(rvc),2);
%rvc(kk <= 0, :) = [];
%kk = sum(abs(rvc),2);
%rvc(kk >= 3, :) = [];
kk = [];
for i=1:numel(rvc(:,1))
    if sum(find(rvc(i,:) < 0)) > 0
        kk = [kk, i];
    end
    if sum(find(rvc(i,:) > 1)) > 0
        kk = [kk, i];
    end
end
rvc(kk,:) = [];
if numel(kk) > 0
    hd = [];
    rvc=[];
    return
end

numvecrt = numel(rvc(:,1));
if numvecrt == 4
    for i=3:numel(rvc(:,1))
        refrv = rvc(i-2,:);
        nom(1) = norm(rvc(i-1,:) - refrv);
        nom(2) = norm(rvc(i,:) - refrv);
        if nom(2) < nom(1)
            tmpv = rvc(i-1,:);
            rvc(i-1,:) = rvc(i,:);
            rvc(i,:) = tmpv;
        end
    end
elseif numvecrt > 4
    mx = mean(rvc(:,1));
    my = mean(rvc(:,2));
    mz = mean(rvc(:,2));
    mp = [mx, my, mz];
    mm = repmat(mp, numvecrt, 1);
    msub = rvc - mm;
    nm0 = norm(msub(1,:));
    U = msub(1,:)/nm0;
    cosang = zeros(numvecrt,1);
    atn2ang = zeros(numvecrt,1);
    ang = cosang;
    for i=2:numel(rvc(:,1))
        nm1 = norm(msub(i,:));
        V = msub(i,:)/nm1;
        [Q, R] = qr([U', V'], 0);
        angle=@(v) atan2(dot(Q(:,2),v),dot(Q(:,1),v));
        ang(i) = mod(angle(V),2*pi);
    end
    [aa, ain] = sort(ang);
    rvc = rvc(ain, :);
end
    

for i=1:numel(rvc)/3
    rvc(i,:) = rvc(i,:)*mat';
end
if numel(rvc(:,1)) > 2
    hd = patch(rvc(:,1), rvc(:,2), rvc(:,3), 'r', 'edgecolor', 'r', 'edgealpha', 1, 'FaceAlpha', 0.7);
else
    hd = [];
end