function obj = voronoishell(x, index_center)
% First, choose a sphere of interest.
% Second, pick a sphere from all list
% Find a equation of a line connecting the centers of the spheres.
% also, find a middle point at the gap.
% Then, we have an equation of a plane that encapsulate the sphere of
% interest.
% Do this for all spheres from the list and find equations of all planes.
% define a polyhedron encapsulaetd by all the planes.
% x should be [x, y, R] or [x, y, z, R]
if size(x, 2) == 3
    dim = 2;
    R = x(:,3);
    x(:, 3) = [];
end
if size(x, 2) == 4
    dim = 3;
    R = x(:, end);
    x(:, end) = [];
end
obj = [];
for i=1:numel(index_center)
    eqn = zeros(size(x, 1)-1, size(x, 2)+1);
    eqn2 = zeros(size(x, 1)-1, size(x, 2));
%    xv = [];
    xc = x(index_center(i), :);
    Rc = R(index_center(i));
    npnt = 0;
    for k=1:size(x, 1)
        if k==index_center(i)
            continue
        end
        x0 = x(k, :);
        R0 = R(k);
        
        v = xc - x0;
        % equation connectin two centers.
        % a line vector = t*v + x0, where v = x0 - xc;
        % Distance between xp to xc is (d+Rc-R0)/2
        % and is sqrt((xc - tv)^2)
        % likewise, distance between xp to x0 is (d-Rc+R0)/2
        % and is sqrt((x0 - tv)^2)
        d = sqrt(sum(v.^2));
        t = (d^2-d*(Rc-R0))/2/dot(v, v);
        xn = t*v+x0;
        D = -dot(t*v, xn);
        if dot(t*v, xc) > -D
            t = -1*t;
            D = -D;
        end
        nv = v/sqrt(sum(v.^2));
        ind = sum((eqn2(:, 1:3) - nv).^2, 2) == 0;
        if sum(ind) > 0
            oldv = eqn(ind, 1:3)*x0'-eqn(ind, 4);
            newv = t*v*x0'+D;
            if newv < oldv
                continue
            end
        end
        npnt = npnt+1;
        % equation of a plane; Ax+By+Cz+D = 0
%    eqn2 = eqn(:, 1:3);
%    eqn2 = eqn2./repmat(sqrt(sum(eqn2.^2, 2)), 1, 3);
%    val = eqn(:, 1:3)*x(2, :)'-eqn(:,4);
        eqn(npnt, :) = [t*v, -D];
        eqn2(npnt, :) = nv;
%        xv(npnt, :) = xn;
    end
    if size(eqn, 1) > npnt
        eqn(npnt+1, :) = [];
    end
    V = MY_con2vert(eqn(:, 1:end-1),eqn(:, end));
    %V = lcon2vert(eqn(:, 1:end-1),eqn(:, end));
    if dim==2
        ind = convhull(V(:,1), V(:,2));
    else
        ind = convhull(V(:,1), V(:,2), V(:,3));
    end
    vert = V(ind, :);
    vert = unique_m(vert);
    faces = findfaces(vert);
    obj(i).vertices = vert;
    obj(i).faces = faces;
end