function [Fq, zz, zp] = EdenFq(q, p)
% q is scattering vector
% p is parameter
% model : centrosymmetric particle
%    model electron density to intensity
% p = [a, c1, c2, .... cn];
% a : width of step function
% c : e-density of the each step function
% n : number of step function
% Jan. 25, 06
% p = [eden, zin, sig] ex, p = [0, 0.5, 1, 0, 80, 10, 5, 5, 5, 5];

%s.eden = [0, 0.5, 1, 0];
%s.zin = [80, 10, 5];  %biggest number should be first.
%s.sig = [5, 5, 5];
numpnt = (length(p)-1)/3;
s.eden = p(1:(numpnt+1));
s.zin = p((numpnt+2):(numpnt*2+1));
s.sig = p((numpnt*2+2):numpnt*3+1);
zend = (s.zin(1) + s.sig(1)*3);
zz = 0:zend/50:zend;
zp = zprofile(zz, s.eden, s.zin, s.sig);

Fq = zeros(size(q));
nomal = 0;q = q+eps;
for i=1:(length(zp)-1)
%    Fq = Fq + p(i).*sinc(q*p(1)).*cos(q*p(i)); % multiple layer(1D structure)
%    Rj = (i-2)*p(1);
    Rj = zz(i);
%    Fq = Fq + (p(i)-p(i+1))*(Rj)*besselj(1, (q+eps)*Rj)./(q+eps);
    Fq = Fq + (zp(i)-zp(i+1))*(Rj)*besselj(1, (q+eps)*Rj)./(q+eps);
%    nomal = nomal + (p(i)-p(i+1))*(Rj)^2;
    nomal = nomal + (zp(i)-zp(i+1))*(Rj)^2;
end
Fq = Fq./nomal;