function [y, name, pnames, pin] = SAXS_FL(x, p, flag)
% this is for Fluorescence subtraction.
% p = [m, fl]
%   m : multiplication factor
%   fl : constant fluorescence
% No fluorescence data should be displayed on mfit plot figure
%   fluorescence data should be defined global variable 'FLdata'
%    file1 = ['D:\SANS\MHlee_010718_21\dsc\PE\separation\DH91.dat'];
%    file2 = ['D:\SANS\MHlee_010718_21\dsc\PE\separation\LDPE.dat'];

if nargin == 2
    
    m = p(1);
    fl = p(2);
    global FLdata

    y1 = spline(FLdata(:,1), FLdata(:,2), x);
    
    y = m*(y1 -fl);
    
    
else
    
   DSC=[];
   name='Fluorescence Subtraction';
   
    pnames=str2mat('m', 'fl');
	if flag==1, pin=[1, 1]; else pin = p; end
   
end       