function f = TMVhalfEllipCylinder(qp, qz, Rp, Rc_per_Rp, Rcbot_per_Rc, rho)
% cylinder with ellipsoid cross section.
% eccentricity axis is qx direction.
% TMVhalfEllipCylinder(qp, qz, Rp, Rc_per_Rp, Rcbot_per_Rc, rho)
% Rp = [Rin2, Rin1, Rout];
% rho = [rho1, rho2, rho3, rho4];
% qp and qz should have a same size....

fq = zeros(size(qz));
for i=1:(length(rho)-1)
	a = (rho(i)-rho(i+1))*cutEllipcylinder(qp, qz, Rp(i), Rc_per_Rp*Rp(i), Rcbot_per_Rc*Rc_per_Rp*Rp(i));
	fq = fq + a;
end
Rcbottom = Rcbot_per_Rc*Rc_per_Rp*Rp(end);
f = fq.*exp(-j*qz*Rcbottom);
%f = abs(fq).^2;%./(qp+eps);

function f = cutEllipcylinder(qp, qz, Rp, Rc, Rcbottom)
dz = Rc/20;
Fq = zeros(size(qz));
for z=-Rcbottom:dz:Rc
	Rz = sqrt(Rc^2-z^2)*Rp/Rc;
	qin = qp*Rz;
	Fq = Fq + dz*Rz*sinc(qin/pi).*sinc(qz*dz/2/pi).*exp(-j*qz*z);
end
f= Fq;
