function [rg, rgp, rgv] = coord2rg(r, a, ra)
% calculate rg from atomic coordinate
% r is a position vector
% a is a mass of each sphere(atom)
% ra is a radius of each sphere(atom).

[ln, dim]=size(r);
if nargin < 2
    a = ones(ln, 1);
    ra = ones(ln, 1);
    meana = 1;
else
    meana = mean(a);
end
rcm = r.*repmat(a, 1, dim)/meana;
rcm = mean(rcm);
r_rcm = r - repmat(rcm, ln, 1);
sum_a2 = sum(a.^2);
a_r2 = repmat(a, 1, dim).^2.*r_rcm.^2;
sphererg = 2/5*a.*ra.^2;
rgp = sqrt(sum(a_r2(:, 1) + a_r2(:, 2) + sphererg)/sum_a2);
rgv = sqrt(sum(a_r2(:, 3) + sphererg)/sum_a2);
rg = sqrt(sum(a_r2(:,1) + a_r2(:,2) + a_r2(:,3) + sphererg)/sum_a2);

