function [Formfactor, name, pnames, pin] = corn_vert_type3(qp, qz, p)
% this is Amplitude for cone type particle : corn_vert_type(qp, qz, p)
% cone is assumed to normal to surface and exact cone(wedge shape)...
% p = [R, H] 
% when Height is not enough, H = R*tan(alpha) will be replaced.
% 2004. May, 14.

    R = p(1);
    H = p(2);alpha = rad2deg(atan(H/R));
%    alpha = p(3);
    
    z = 0:H/10:H;
    lengthz = length(z);

    [qp, qz, z] = meshgrid(qp, qz, z);

    Rz = R - z/tan(deg2rad(alpha));
    
    F = zeros(size(z));
    F = 2*pi*Rz.^2.*besseljc(qp.*Rz).*exp(-j.*qz.*z)*H/50;
    Formfactor = sum(F, 3);
