function [y, pq, sq] = cylinder_vert_clusters_pDist(x, pDist, HperR, I0, strfactor, strp)
% [y, name, pnames, pin] = pedersen_pDist(x, pDist, p)
% Pedersen formalism to calculate scattering intensity from a given distribution function.
% Local monodisperse approximation assumed.
% Formfactor assumed as sphere scattering.
% Structure factor : Hard sphere
% pDist = [x, Dist];
% p = [I0, volfrac, back];
sq = [];pq=[];
if nargin > 4;
    xx = pDist(:, 1);
    gDist = pDist(:, 2);
%    fn = fieldnames(strp);
%    df = strp.(fn{1});
%    dfa = strp.(fn{2});
    
%    df = strp.dspacing;
%    dfa = strp.sig;
%    normFactor = sum(gDist.*xx.^6);  % for sphere
    normFactor = sum(gDist.*(xx.^6))*HperR^2;  % for cylinder
    y = zeros(size(x));
        %Form = spheretype(x, xx(i))*xx(i)^6;  % let's discribe using volume distribution... because I don't want exaggerate small size particle...
        if isfield(x, 'q')
            qpa = x.qpa;
            q1z = x.q1z;
            q2z = x.q2z;
            q3z = x.q3z;
            q4z = x.q4z;
            Ti = x.Ti;
            Tf = x.Tf;
            Ri = x.Ri;
            Rf = x.Rf;
            GI = 1;
        else
            x = x(:);
            qpa = x;
            q1z = 0;
            q2z = 0;
            q3z = 0;
            q4z = 0;
            Ti = 1;
            Tf = 0;
            Ri = 0;
            Rf = 0;
            GI = 0;
        end
    for i = 1:length(xx)
%        F1 = cylinder_vert_type(qpa, q1z, [xx(i), xx(i)*HperR]);
%        F2 = cylinder_vert_type(qpa, q3z, [xx(i), xx(i)*HperR]);
        if GI == 1
            F = dwbacyl(qpa, q1z, q2z, q3z, q4z, Ti, Tf, Ri, Rf, xx(i), HperR*xx(i), [1, 0], 0);
%            F = q4z;
        else
            %F = cylinder_vert_type(qpa, q1z, [xx(i), xx(i)*HperR]);
            %[F, avFq2] = hollowCylinderForm2(qpa, [xx(i), xx(i)*0.5], [1,0,0],0);
            [F, avFq2] = hollowCylinderForm2(qpa, [xx(i)*0.23, xx(i)], [0, 1,0],0);
        end
        dfa = 2.05*23.8;
        df = strp; 
        %Struc = feval(strfactor, x, dfa*xx(i), xx(i)*df*dfa); % for strfactor_2Dpara
        Struc = feval(strfactor, x, dfa, df*dfa); % for strfactor_2Dpara
        %Struc = feval(strfactor, x, xx(i), xx(i)*df); % for strfactor_2Dpara
%        Struc = feval(strfactor, x, strp, xx(i));  % for strfactor2
        %Struc = feval(strfactor, x, xx(i), strp);  % for strfactor2
        %Struc = ones(size(F));
        y = y + abs(F).^2.*Struc*gDist(i);
        pq = [pq, abs(F).^2*gDist(i)];
        sq = [sq, Struc];
    end
    y = y*I0/normFactor;
end
