function [Formfactor, name, pnames, pin] = cylinder_vert_type_out(x, p, flag)
% [Formfactor, name, pnames, pin] = cylinder_vert_type_out(x, p, flag)
% cylinder is assumed to normal to surface.
% p = [R, L, I0) 
% 2004. Feb, 4
j = sqrt(-1);

if nargin == 2
    [xq, yq] = size(x);

    if xq < yq 
        x = x(:);
    end
    qz = real(x);
    
    R = p(1);
    H = p(2);
    I0 = p(3);
    w = p(4);
    qp = p(5);
    
    F = 2*pi*R.^2.*H.*bessel(1, qp.*R)./(qp.*R).*sin(qz.*H/2)./(qz.*H/2).*exp(-j.*qz.*H/2);
    Fnorm = 2*pi*R.^2.*H.*bessel(1, qp.*R)./(qp.*R).*sin(0.0001.*H/2)./(0.0001.*H/2).*exp(-j.*0.0001.*H/2);
    F = abs(F).^2;
    Fnorm = abs(Fnorm).^2;
    F = F/max(abs(Fnorm));
    Formfactor = F*I0;lenqz = length(qz);
    y = gauss(-fix(lenqz/2):fix(lenqz/2), [1, 0, w, 0]);
    Formfactor = convlv(Formfactor, y)/sum(y).*exp(-R.*qz.^2);
else
    
   Formfactor=[];
   name='Cylinder Model';
   
    pnames=str2mat('R','L','I0', 'wdith', 'qp');
	if flag==1, pin=[10 1 1, 0, 0]; else pin = p; end
   
end       