function [y, p1, p2] = mirkin_twosphere(q)
rs = 43;
rl = 69;
%q = 0.005:0.001:0.2;
%q = sqrt(qx.^2 + qy.^2 + qz.^2);
var = 1.37;
Dsp = rl*(1+var)*2;
disorder = (Dsp/2-rl);
Fs = sphereamp(q, rs);
Fl = sphereamp(q, rl);
p1 = makesc(5, 5, 5, Dsp);
%p1 = makefcc(20, 20, 20, Dsp);
pshift = zeros(size(p1))+Dsp/2;  % shift for BCC/simple cubic
%pshift = zeros(size(p1));pshift(:,1)=pshift(:,1)+Dsp;  % shift for FCC/simple cubic
p2 = p1 + pshift;
%k = visualsphere(40, p1);
%p1 = addrand(p1, disorder);
%p2 = addrand(p2, disorder);
p1(:,4) = 1;
p2(:,4) = 2;
p = [p1;p2];
%p = [p1];
F = [vect2row(Fl)', vect2row(Fl)'];
y = debye(q, p, F);
%y2 = Fs.*debye(q, p2);
%y = abs(y1+y2).^2;
end



function c = sc(x, d, shift)
    % d : unit cell size
    % shift : integer, base unit is d.
c(1, :) = x;
c(2, :) = [x(1) + d, x(2), x(3)];
c(3, :) = [x(1), x(2) + d, x(3)];
c(4, :) = [x(1) + d, x(2), x(3) + d];
c(5, :) = [x(1), x(2) + d, x(3) + d];
c(6, :) = [x(1) + d, x(2), x(3) + d];
c(7, :) = [x(1) + d, x(2) + d, x(3)];
c(8, :) = [x(1) + d, x(2) + d, x(3) + d];
c = c + shift*d;
end

function c = addrand(x, var)
    % maximum variation.
    y = rand(size(x));
    y = y - 0.5;
    y = y*var;
    c = y + x;
end

function c = makesc(x,y,z,d)
    % x, y, z are number of unit cell along the each direction.
%    s = sc([0,0,0], d, 0);
    c = [];
    for k=0:1:x
        for l=0:1:y
            for m=0:1:z
                c = [c;[k, l, m]];
            end
        end
    end
    c = c*d;
end


function c = makefcc(x,y,z,d)
    % x, y, z are number of unit cell along the each direction.
%    s = sc([0,0,0], d, 0);
    c = [];
    for k=0:1:x
        for l=0:1:y
            for m=0:1:z
                if mod(m+k+l, 2) == 0
                    c = [c;[k, l, m]];
                end
            end
        end
    end
    c = c*d;
end