function [Z1, Z2, Z3, TH] = paraBCC(q, A, delA, th, ph)
% paracrystalline BCC lattice factor, angle should be radian unit
% Assumption 
%  1. |a1| = |a2| = |a3| = a, here denoted as A.
%  2. isotropic distortion.
[Q, TH, PH] = meshgrid(q, th, ph);
Q;
TH;
PH;
Expterm = exp(-Q.^2*delA^2);
Expterm2 = exp(-1/2*Q.^2*delA^2);
Z1 = (1-Expterm) ./ ( 1 - 2*Expterm2.*cos(1/2*Q*A.*(sin(TH).*cos(PH) + sin(TH).*sin(PH) + cos(TH))) + Expterm );
Z2 = (1-Expterm) ./ ( 1 - 2*Expterm2.*cos(1/2*Q*A.*(-1*sin(TH).*cos(PH) - sin(TH).*sin(PH) + cos(TH))) + Expterm );
Z3 = (1-Expterm) ./ ( 1 - 2*Expterm2.*cos(1/2*Q*A.*(-1*sin(TH).*cos(PH) + sin(TH).*sin(PH) - cos(TH))) + Expterm );