function [Iq, r, pr, pv] = saxsPolyhedron2(q, obj, forOrgn)
% function [Iq, r, pr, pv] = saxsPolyhedron(q, obj, forOrgn)
% This is develped for calculating Iq of any polyhedron
% for example.
% obj = polyhedra('icosahedron')
% and its stellated. 
% for instance
% obj = stellate(obj.faces, obj.vertices, 100*sqrt(2/3));
% This is analog of saxsPolyhedron.m
% Difference is saxsPolyhedron2.m uses Monte-Carlo..

if nargin < 3
    forOrgn = 0;
end

dist = distancePoints(obj.vertices(:,:), [0,0,0]);
mdist = max(dist);
pv = -mdist + 2*mdist*rand(1E5, 3);

%inP = inpolyhedron(obj, pv);
if forOrgn == 1
    if isfield(obj, 'original');
        obj = obj.original;
    end
end
inP = inPolyhedron2(obj, pv);
k = inP==0; pv(k, :) = [];
[Iq, r, pr] = debyepr(q, pv(:,1), pv(:,2), pv(:,3), 500);