function F = saxs_abigail(qx, qy, qz, parameters)
% J. appl. cyrst (2002), 35, 406
% Lazzari
casewhat = parameters(1);
R = parameters(2);
H = parameters(3);
F1 = saxsprism3(qx, qy, qz, [R, H]);
switch casewhat
    case 1
        F2 = F1.*exp(-j*qz*H);
    case 2
        qxt = cos(pi)*qx + sin(pi)*qy;
        qyt = -sin(pi)*qx + cos(pi)*qy;
        F2 = saxsprism3(qxt, qyt, qz, [R, H]).*exp(-j*qy*(4/sqrt(3))*R);
    case 3
        qxt = cos(pi)*qx + sin(pi)*qy;
        qyt = -sin(pi)*qx + cos(pi)*qy;
        F2 = saxsprism3(qxt, qyt, qz, [R, H]).*exp(-j*qy*(-2/sqrt(3))*R);
    otherwise
        F2 = 0;
end
F = F1 + F2;