function F = saxs_polyhedron_Croset(qx, qy, qz, ph)
% assuming vertices_on_face are already sorted such that the direction is
% the same.
% isCounterClockwise is checking rotation direction seen from [0, 0, 0]
% so, first move the polyhedron CM to O.
qv = [qx(:), qy(:), qz(:)];
q = sqrt(sum(qv.^2, 2));

v = ph.vertices;
f = ph.faces;
F = 0;
for i=1:size(v, 1)
    % find faces that includes vertex i
    if iscell(f)
        ind = cell2mat(cellfun(@(x) ~isempty(find(x==i, 1)), f, 'uniformoutput', false));
        ftemp = f(ind);
        N_neighbor_face = numel(ftemp);
    else
        ind = any(f == i, 2);
        ftemp = f(ind, :);
        N_neighbor_face = size(ftemp, 1);
    end
    Neighbor_vertices_index = zeros(N_neighbor_face, 1);
    for k=1:N_neighbor_face
        if k<N_neighbor_face
            kplus1 = k+1;
        else
            kplus1 = 1;
        end
        if iscell(ftemp)
            pnt = intersect(ftemp{k}, ftemp{kplus1});
        else
            pnt = intersect(ftemp(k,:), ftemp(kplus1, :));
        end
        Neighbor_vertices_index(k) = pnt(pnt ~= i);
    end
    Neighbor_vertices = v(Neighbor_vertices_index, :);
    seq = planeconstruct(Neighbor_vertices, v(i, :));
    Neighbor_vertices = Neighbor_vertices(seq, :);
    
    Fi = 0;
    for k=1:N_neighbor_face
        if k<N_neighbor_face
            kplus1 = k+1;
        else
            kplus1 = 1;
        end
        AwisAi = repmat(Neighbor_vertices(k, :)-v(i, :), size(qv, 1), 1);
        Awis1Ai = repmat(Neighbor_vertices(kplus1, :)-v(i, :), size(qv, 1), 1);
        Fi = Fi + dot(qv, cross(AwisAi, Awis1Ai, 2), 2)...
            ./dot(qv, AwisAi, 2)./dot(qv, Awis1Ai, 2)./q.^2;
    end
    OAi = repmat(-v(i, :), size(qv, 1), 1);
    F = F + Fi.*exp(-sqrt(-1)*dot(qv, OAi, 2));
end
F = sqrt(-1)*F;