function [F, V, S] = saxstetrahedron3(qx, qy, qz, L)
% This gives identical result with saxstetrahedron.m and saxstetrahedron2.m
% However, the most accurate at qx~0 and qy~0.
% try 
% y = -0.5:0.01:0.5;
% [qy, qz] = meshgrid(y, y);
% [F,V]=saxstetrahedron3(qx+eps,qy,qz,100); and imagesc(log10(abs(F).^2))
%
% In order to get more accurate result, reduce dz in the code.
% B. Lee
% Nov, 2012

if numel(L) == 2;
    H = L(2);
    L = L(1);
else
    H = sqrt(2/3)*L;
end
R = L/2;
tanalp = H/R*sqrt(3);
%qxsize = size(qx);
qx = qx+eps;
qy = qy+eps;
qz = qz+eps;
V = 1/3*tanalp*(R^3-(R-sqrt(3)*H/tanalp)^3);
S = 4*R*sqrt(H^2+R^2/3);

j = sqrt(-1);

z = linspace(0, H, 10);
dz = z(2)-z(1);
F = zeros(size(qx));
for i=2:numel(z)
    pz = (z(i)-dz/2);
    Rz = R - sqrt(3)/tanalp*pz;
    %A = 2*sqrt(3)*exp(j*Rz/sqrt(3)*qy)./qy./(qx.^2-3*qy.^2);
    %B = qx.*exp(-j*sqrt(3)*Rz*qy)-qx.*cos(qx*Rz)+3*j*qy.*sin(qx*Rz);
    %F0 = A.*B;
    F0 = saxsprism3(qx, qy, qz, [Rz, dz]);
    %F = F + F0.*exp(-j*qz*pz).*sinc(qz*dz/2)*dz;
    F = F + F0.*exp(-j*qz*pz);
end

%F = reshape(F, qxsize);
end