function F = saxstriangle2(qx,qy,R)
%F = saxstriangle(qx,qy,R,angle)
% analytical form factor of a regular triangle
% AC = AB = BC = 2*R;
% center of mass, D, is at [0,0]
%            . A
%           .  .
%          .    .
%         .       .
%        .    D    .
%      B. . . . . . .C
%
%
% bottom of the triangle is parallel to x axis
% its center of mass is on negative side of y axis.
% derived by Byeongdu Lee. 2006, 2, 12.
j = sqrt(-1);
D = qx.*(qx.^2-3*qy.^2);
F = 2*sqrt(3)./D.*exp(j*R/sqrt(3)*qy);
F = F.*(qx.*exp(-j*sqrt(3)*R*qy)-qx.*cos(qx*R)+j*sqrt(3)*qy.*sin(qx*R));