function [Formfactor, name, pnames, pin] = sphere_vert_type(qp, qz, p, flag)
% this is Amplitude for cylinder type particle : cylindertype(qp, qz, p)
% cylinder is assumed to normal to surface.
% qp could be vector
% qz should be just point(one value)
% or either qp or qz should be point value.....
% p = [R, L, I0) 
% 2004. Feb, 4

qp = real(qp);qz = real(qz);

if p(2)/p(1) > 2
    p(2) = 2*p(1);
%    disp('too small alpha value')
%    return
end

    R = p(1);
    H = p(2);
    
    z = 0:H/20:H;
    lengthz = length(z);

    [qp, qz, z] = meshgrid(qp, qz, z);
    dz = H/20;

    x = abs(z - H + R);
    Rz = sqrt(R.^2 - x.^2);
    
    F = zeros(size(z));
    qpRz = qp.*Rz;
    [xzero, yzero] = find(qpRz == 0);qpRz(xzero, yzero) = 0.0001;
    F = 2*pi*Rz.^2.*bessel(1, qpRz)./(qpRz).*exp(j.*qz.*z)*dz;
    Formfactor = sum(F, 3);
