%close all;
%clear all;

warning off;

%Debug information
%
%global debugFlag
%debugFlag = 1

%Potential From: V(r)/(kB*T)=-K1*exp(-Z1*(r-1))/r - K2*exp(-Z2*(r-1))/r
%kB: Boltzman constant
%T: Absolute temperature
%The hardcore diameter is assumed to be one

Z1=0.51;
Z2=0.1;
K1=0.33;           %Attraction
K2=-0.9;          %Repulsion

%Volume Fraction
volF=0.21;

%Please give your Q range, the maximum Q should be larger than 700 to let
%the program to run.
%(The reason is : we have to use g(r) to select the right result. Therefore
%large Q range can make g(r) better.
Q=(0:0.005:16*10)*2*pi;
%Q=(0:0.005:16*10)*2*pi;

[calSk,rootCounter,calr,calGr,errorCode]=CalTYSk(Z1,Z2,K1,K2,volF,Q);

figure(1);
subplot(2,1,1);
%Plot structure factor S(Q)
plot(Q,calSk,'bo');
axis([0,20,0,inf]);

%Plot the pair distribution function g(r)
%figure
subplot(2,1,2);
plot(calr, calGr,'bo-');
axis([0,10,-inf,inf]);
