function [err, imgc, integInt] = fitwith2dgaussian(p, img, vargin)
% for fitting peaks on 2D images;
% called from fitpeaktoggleup in SAXSimageviewer.m
%
    param = [];
    x_img = vargin{1};
    y_img = vargin{2};
    if numel(vargin) > 2
        Nbackparam = vargin{3};
    else
        Nbackparam = 0;
    end
    if numel(p) < 10
        numpeak = 1;
        Nbackparam = numel(p) - 6;
    else
        if ~isempty(Nbackparam)
            numpeak = numel(p)/(6+Nbackparam);
        end
    end
    
    imgc = zeros(size(x_img));
    
    for i=1:numpeak
        param{i}(1) = p((i-1)*6+1);
        param{i}(2) = p((i-1)*6+2);
        param{i}(3) = p((i-1)*6+3);
        param{i}(4) = p((i-1)*6+4);
        param{i}(5) = p((i-1)*6+5);
        param{i}(6) = p((i-1)*6+6);
        imgc = imgc+gauss2d(x_img, y_img, param{i});
    end
    backind = 7:(7+Nbackparam-1);
    backparam = p((i-1)*6+backind);
    if ~isempty(backparam)
        bac = background2d(x_img, y_img, backparam);
    else
        bac = 0;
    end
    integInt = sum(img(:)-bac(:));
    imgc = imgc+bac;
    try
        err = sum((img(:)-imgc(:)).^2);
    catch
        err = 10000;
    end
end
