function Sq = integCorr_qyavg(qx, qz1, qz2, sig1, sig2, zint1, zint2, hcor, vcor, H)
qx = real(qx);
Sq = qx;
if length(qx) == length(qz1)
    y = 0.001;
    rmax = hcor*exp(log(log(1/y))/2/H);
    rr = 0:rmax/2048:rmax;
    dr = rmax/2048; 

    for i=1:prod(size(length(qz1)))
        t = abs(zint1-zint2)/vcor;
        Cr = sig1*sig2*exp(-(rr/hcor).^(2*H)-t);
        Cr = (exp((qz1(i).*qz2(i)).*Cr)-1).*cos(qx(i).*rr);
        Sq(i) = trapz(Cr)*dr; 
    end
else % when dimensions of qx and qz1 are different, dim of qz1 should be always 1,
     % which means, on the other hands, dims of qx and qz1 are the same,
     % whenever dim of af or ai is bigger than 0 D and so is dim of tthi or tthf...
    y = 0.001;
    rmax = hcor*exp(log(log(1/y))/2/H);
    rr = 0:rmax/2048:rmax;
    dr = rmax/2048; 
    for i=1:length(qx)
        t = abs(zint1-zint2)/vcor;
        Cr = sig1*sig2*exp(-(rr/hcor).^(2*H)-t);
        Cr = (exp((qz1.*qz2).*Cr)-1).*cos(qx(i).*rr);
        Sq(i) = trapz(Cr)*dr; 
    end
end    

