function [hkn, m, mf] = mfhkl(hklin, X, Y, Z)
% [m,mhkl] = mfhkl(hklin, X, Y, Z)
% ref. Forster, J.P.C, 2005
% Multiplicity for film, 2D powder
% Input : hklin = diffraction peak family ex [1 1 1]
% R is rotation matrix, z axis should be epitaxy
% if X, Y, Z is
if nargin < 4
    if numel(X) == 9
        R = X;
    end
else
    [b1, b2, b3, R] = cubicOrient(X, Y, Z); % get a rotation matrix to rotate X, Y, Z to [100],[010], and [001];
end

h=hklin(1);k=hklin(2);l=hklin(3);
hkl = familyplane([h,k,l]); % get all peaks of {h, k, l} family.
hkln = (R*hkl')'; % perform rotation operation.
% ==============================================
% if Cubic lattice ....
hk = [sqrt(hkln(:,1).^2 + hkln(:,2).^2), hkln(:,3)];
% if it is not Cubic lattice....
%
% ============================================

hk = round(hk*10000)/10000;
[hkn, m, mf] = reducehk(hk, hkl);m=m';