function m = mphkl(hklin, lattice)
% ref. Forster, J.P.C, 2005
% Multiplicity for Powder
h=hklin(1);k=hklin(2);l=hklin(3);
Lat = lattice;
switch lattice
case 'BCC'
    Lat = 'Cubic';
case 'FCC'
    Lat = 'Cubic';
case 'HCP'
    Lat = 'Hexagonal';
case 'HPL' %Hexagonal ABC type
    Lat = 'Hexagonal';
end

switch Lat
case 'Lam'
    m = 1;
case 'Hex'
    if (h ~= 0) & (k == 0)
        m = 6;
    end
    if (h == k) & (k ~= 0)
        m = 6;
    end
    if (h ~= k) & (h ~= 0) & (k ~= 0)
        m = 12;
    end
case 'Sq' % Square
    if (h ~= 0) & (k == 0)
        m = 4;
    end
    if (h == k) & (k ~= 0)
        m = 4;
    end
    if (h ~= k) & (h ~= 0) & (k ~= 0)
        m = 8;
    end
case 'Cubic'
    if (h ~= k) & (k ~= l) & (l ~= h)
        m = 48;
    end
    if (h == k) & (l ~= h)
        m = 24;
    end
    if (h == 0) & (k ~= l) & (k ~= h) & (l ~= h)
        m = 24;
    end
    if (h ==0) & (k == l) & (k ~= h) & (l ~= h)
        m = 12;
    end
    if (h == k) & (k == l)
        m = 8;
    end
    if (h ==0) & (k == 0) & (l~=0)
        m = 6;
    end
    
case 'Hexagonal'
    if (h ~= k) & (k ~= l) & (l ~= h)
        m = 24;
    end
    if (h == k) & (l ~= h)
        m = 12;
    end
    if (h == 0) & (k ~= l) & (k ~= h) & (l ~= h)
        m = 12;
    end
    if (l == 0) & (h ~= k) & (h ~= l) & (k ~= l)
        m = 12;
    end
    if (l == 0) & (h == k) & (h ~= l) & (k ~= l)
        m = 6;
    end
    if (h ==0) & (l == 0) & (k~=0)
        m = 6;
    end
    if (h ==0) & (k == 0) & (l~=0)
        m = 2;
    end
case 'Tetragonal'
    if (h ~= k) & (k ~= l) & (l ~= h)
        m = 16;
    end
    if (h == k) & (l ~= h)
        m = 8;
    end
    if (h == 0) & (k ~= l) & (k ~= h) & (l ~= h)
        m = 8;
    end
    if (l == 0) & (h ~= k) & (h ~= l) & (k ~= l)
        m = 8;
    end
    if (l == 0) & (h == k) & (h ~= l) & (k ~= l)
        m = 4;
    end
    if (h ==0) & (l == 0) & (k~=0)
        m = 4;
    end
    if (h ==0) & (k == 0) & (l~=0)
        m = 2;
    end
case 'Orthorhombic'
    if (h ~= k) & (k ~= l) & (l ~= h)
        m = 8;
    end
    if (h == 0) & (k ~= l) & (k ~= h) & (l ~= h)
        m = 4;
    end
    if (k == 0) & (h ~= l) & (h ~= k) & (l ~= k)
        m = 4;
    end
    if (l == 0) & (h ~= k) & (h ~= l) & (k ~= l)
        m = 4;
    end
    if (k ==0) & (l == 0) & (h~=0)
        m = 2;
    end
    if (h ==0) & (l == 0) & (k~=0)
        m = 2;
    end
    if (h ==0) & (k == 0) & (l~=0)
        m = 2;
    end
case 'Monoclinic'
    if (h ~= k) & (k ~= l) & (l ~= h)
        m = 4;
    end
    if (k == 0) & (h ~= l) & (h ~= k) & (l ~= k)
        m = 2;
    end
    if (h ==0) & (l == 0) & (k~=0)
        m = 2;
    end
case 'Triclinic'
    if (h ~= k) & (k ~= l) & (l ~= h)
        m = 2;
    end
end